#include <win.h>
#include "mex.h"

#define LVM_FIRST 0x1000
#define LVM_GETHEADER (LVM_FIRST + 31)

//#define HDI_TEXT   0x2
//#define HDI_FORMAT 0x4
//#define HDI_BITMAP 0x10
#define HDI_IMAGE  0x20

#define HDF_IMAGE           0x800
#define HDF_BITMAP_ON_RIGHT 0x1000
//#define HDF_BITMAP          0x2000
//#define HDF_STRING          0x4000

#define HDM_FIRST         0x1200
//#define HDM_SETITEM       (HDM_FIRST + 4)
#define HDM_SETIMAGELIST  (HDM_FIRST + 8)
#define HDM_GETIMAGELIST  (HDM_FIRST + 9)

struct
{
   long mask;
   long cxy;
   char *pszText;
   long hbm;
   long cchTextMax;
   long fmt;
   long lParam;
   long iImage;
   long iOrder;
} HD;

// Compilation Command: mex setSortIcon.c
// setSortIcon params: ListView.hwnd, columnNumber, iconIndex
// See: http://vbnet.mvps.org/index.html?code/comctl/lvheaderimage.htm
void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
    if ((nrhs >= 3))
    {
        // get input params
        HWND hwnd         = (HWND)(long)(mxGetScalar(prhs[0]));
        long columnNumber = (long)(mxGetScalar(prhs[1]));
        long iconIndex    = (long)(mxGetScalar(prhs[2]));

        // get a handle to the listview header component
        HWND hHeader = (HWND) SendMessage(hwnd, LVM_GETHEADER, 0, 0);

        // set up the required structure members
        HD.mask = HDI_IMAGE | HDI_FORMAT;
        HD.fmt = HDF_STRING | HDF_IMAGE | HDF_BITMAP_ON_RIGHT;
        HD.iImage = iconIndex;

        // modify the header
        SendMessage(hHeader, HDM_SETITEM, columnNumber, (LPARAM) &HD);
    }
}
